import java.io.File;
import java.io.FileWriter;
import java.io.IOException;


/**
 * Logs public game information into a file. Used to create data files of sample games to NARS.
 */
public class FileLogger {

    private FileWriter fw;
    public FileLogger(String filename){
        try {
            fw = new FileWriter(filename);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    public void log(String message) {
        System.out.println(message);
        try {
            fw.write(message + "\n");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    public void closeLog(){
        try {
            fw.close();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }
}
