import java.util.*;

public class Player {

    public Scanner sc = new Scanner(System.in);
    private final int playerNumber;
    public final static Map<Integer, String> playerNames = Map.of(1, "A", 2, "B", 3, "C", 4, "D", 5, "E", 6, "F", 7, "G", 8, "H", 9, "I", 10, "J");

    public boolean doneDeliberating;

    public Player(int playerNumber){
        this.playerNumber = playerNumber;
        this.doneDeliberating = false;
    }

    public void deliberate(){
        System.out.println(playerNames.get(playerNumber) + ", select a deliberation option:");
        System.out.println("1.) Accuse another player.");
        System.out.println("2.) Vouch for another player.");
        System.out.println("3.) Done deliberating.");
        try {
            int select = sc.nextInt();
            if(select == 1){
                System.out.println("Select another player to accuse: ");
                int playerAccused = sc.nextInt();
                ResistanceDriver.logger.log(playerNames.get(playerNumber)  + " accuses " + playerNames.get(playerAccused)  + " of being a spy.");
            }else if(select == 2){
                System.out.println("Select another player to vouch for: ");
                int playerVouchedFor = sc.nextInt();
                ResistanceDriver.logger.log(playerNames.get(playerNumber) + " vouches for " + playerNames.get(playerVouchedFor)  + ".");
            }
            else {
                ResistanceDriver.logger.log(playerNames.get(playerNumber)  + " is done deliberating.");
                doneDeliberating = true;
            }
        }catch (InputMismatchException e){
            System.out.println("Not a valid input...");
            doneDeliberating = true;
        }
    }

    /**
     * Get the player to select a mission team.
     * @param missionTeam
     * @param numPlayers
     * @param teamSize
     */
    public void playerSelectTeam(ArrayList<Integer> missionTeam, int numPlayers, int teamSize){
        missionTeam.clear();
        while(missionTeam.size() < teamSize){
            System.out.println("Current team: " + missionTeamString(missionTeam) + ". Team size required: " + teamSize);
            System.out.println(playerNames.get(playerNumber)  + ", add a team member to the mission: (1-" + numPlayers + "):");
            try{
                int playerNumber = 0;
                playerNumber = sc.nextInt();
                if(playerNumber <= 0 || playerNumber > numPlayers)
                    System.out.println("Enter a number between 1 and " + numPlayers + ".");
                else if(!missionTeam.contains(playerNumber))
                    missionTeam.add(playerNumber);
            } catch (InputMismatchException e){
                if(sc.hasNext())
                    sc.next();

                System.out.println("Not a valid input...");
            }
        }
        ResistanceDriver.logger.log(playerNames.get(playerNumber) + " proposes the team: " + missionTeamString(missionTeam));
    }


    public boolean voteOnMissionTeam(ArrayList<Integer> missionTeam){

        String answer = "";
        do{
            System.out.println("Proposed team: " + missionTeamString(missionTeam));
            System.out.println(playerNames.get(playerNumber)  + ", vote Y/N on proposed team:");
            answer = sc.next();
        } while(!(answer.equalsIgnoreCase("Y") || answer.equalsIgnoreCase("N")));
        ResistanceDriver.logger.log((playerNames.get(playerNumber) + " votes " + answer.toUpperCase() + " on proposed team " + missionTeamString((missionTeam))));
        return answer.equalsIgnoreCase("Y");
    }

    public boolean goOnMission(){
        String answer = "";
        do{
            System.out.println(playerNames.get(playerNumber)  + ", pass or fail the mission (Y = pass/N= fail); resistance members must pass:");
            answer = sc.next();
        } while(!(answer.equalsIgnoreCase("Y") || answer.equalsIgnoreCase("N")));
        return answer.equalsIgnoreCase("Y");
    }


    private String missionTeamString(ArrayList<Integer> missionTeam){
        String s = "[";
        for(int i = 0; i < missionTeam.size()-1; i++)
        {
            s += playerNames.get(missionTeam.get(i)) + ", ";
        }
        if(missionTeam.size()!=0)
            s += playerNames.get(missionTeam.get(missionTeam.size()-1));
        s += "]";
        return s;
    }
}
